/**
 * \file
 *
 * \brief I2C]uײ
 * Atmel STARTI2C]uײނɊÂĊȌg
 * ȑfI2C]uײ
 *
 * \page 
 *
 * (c) 2018 Microchip Technology Inc.Ǝq
 *
 * ̏̏ƂāAMicrochipĳƉ̔hMicrochipi
 * ɌĎgp邱Ƃł܂BMicrochipĳ𔺂Ȃ(J 
 * ĳ܂)Oҿĳ̎gpɓKpO҂̋炷̂͂
 * ̐ӔCłB
 *
 * ̿ĳMicrochip"󂻂̂܂"ɂċ܂BNQAiA
 * ړIւ̓K̂ǂ̈Öق̕ۏ؂܂߁AIAÎI܂͖@߂ł낤
 * ̿ĳɂ͓Kp܂BႦMicrochip\iꂽAQ\
 * ƂĂA̔@Ɋւ炸A@ȂꍇłMicrochipͿĳɊ֘A
 * @Ȃނ̊ԐړIAʁAIAI܂͕KRIȑAQAp
 * ͎x̐ӔC𕉂܂B@ɂċő͈̔͂܂ŁA̿ĳ
 * Ɋ֘Aǂ̕@ł̑SɉĂAmicrochip̑ӔCźA΁A
 * Ȃ̿ĳɑ΂Microchip֒ڎxp̊z𒴂܂B
 */

#include <avr/io.h>
#include <stdbool.h>
#include "i2c_slave.h"

// TWI Slave Driver Struct
i2c_slave_t i2c_driver = {
	.status = I2C_STATUS_READY,
	.result = I2C_RESULT_UNKNOWN,
};

// ǂݍݎۊ荞ݏ
void i2c_slave_read_handler(void);

// ݎۊ荞ݏ
void i2c_slave_write_handler(void);

// ڽۊ荞ݏ
void i2c_slave_address_handler(void);

// ~ۊ荞ݏ
void i2c_slave_stop_handler(void);

// ޽Փˎۊ荞ݏ
void i2c_slave_collision_handler(void);

// وُ펖ۊ荞ݏ
void i2c_slave_bus_error_handler(void);

// PʏI
void i2c_slave_transaction_finished(i2c_status_t result);

void i2c_slave_init()
{

	// TWI0.CTRLA = 0 << TWI_FMPEN_bp	/* FM+: ֎~ */
	//       | TWI_SDAHOLD_OFF_gc		/* SDAێOFF */
	//       | TWI_SDASETUP_4CYC_gc;	/* SDAԂ4ۯ */

	// TWI0.DBGCTRL = 0 << TWI_DBGRUN_bp;	/* ޯނős: ֎~ */

	TWI0.SADDR = I2C_SLAVE_ADDRESS << TWI_ADDRMASK_gp	/* ]uڽ */
	             | 0 << TWI_ADDREN_bp;	/* ČĂяoF: ֎~ */

	// TWI0.SADDRMASK = 0 << TWI_ADDREN_bp	/* ڽՕ: ֎~ */
	//       | 0x0 << TWI_ADDRMASK_gp;	/* ڽՕ: 0x00 */

	TWI0.SCTRLA = 0 << TWI_APIEN_bp		/* ڽ/~荞݋: ֎~ */
	              | 0 << TWI_DIEN_bp	/* ް荞݋: ֎~ */
	              | 1 << TWI_ENABLE_bp	/* TWI]u:  */
	              | 1 << TWI_PIEN_bp	/* ~荞݋:  */
	              | 0 << TWI_PMEN_bp	/* SڽFؓ싖: ֎~ */
	              | 1 << TWI_SMEN_bp;	/* Ȍ싖:  */
				  
	TWI0.MCTRLA = 1 << TWI_ENABLE_bp;	/* TWI呕u: A޽ُ팟op */
}

void i2c_slave_open(void)
{
	TWI0.SCTRLA |= TWI_ENABLE_bm;
}

void i2c_slave_close(void)
{
	TWI0.SCTRLA &= ~TWI_ENABLE_bm;
}

void i2c_slave_isr()
{
	if(TWI0.SSTATUS & TWI_COLL_bm) {
		i2c_slave_collision_handler();
	}

	if(TWI0.SSTATUS & TWI_BUSERR_bm) {
		i2c_slave_bus_error_handler();
	}

	if(TWI0.SSTATUS & TWI_APIF_bm) {
		if(TWI0.SSTATUS & TWI_AP_bm) {
			i2c_slave_address_handler();
		} else {
			i2c_slave_stop_handler();
		}
	}

	if(TWI0.SSTATUS & TWI_DIF_bm) {
		if(TWI0.SSTATUS & TWI_DIR_bm) {
			/* 呕u]uǂƂ܂B */
			i2c_slave_write_handler();
		} else {
			/* 呕u]u֏Ƃ܂B */
			i2c_slave_read_handler();
		}
	}
}

uint8_t i2c_slave_read(void)
{
	return TWI0.SDATA;
}

void i2c_slave_write(uint8_t data)
{
	TWI0.SDATA = data;
}

void i2c_slave_enable(void)
{
	TWI0.SCTRLA |= TWI_ENABLE_bm;
}

void i2c_slave_send_ack(void)
{
	TWI0.SCTRLB = TWI_ACKACT_ACK_gc | TWI_SCMD_RESPONSE_gc;
}

void i2c_slave_send_nack(void)
{
	TWI0.SCTRLB = TWI_ACKACT_NACK_gc | TWI_SCMD_COMPTRANS_gc;
}

void i2c_slave_send_comptrans(void)
{
	TWI0.SCTRLB = TWI_SCMD_COMPTRANS_gc;
}

void i2c_slave_goto_unaddressed(void)
{
	/* Pʕؾ */
	TWI0.SSTATUS = TWI_DIF_bm | TWI_APIF_bm;
	i2c_slave_send_comptrans();
}

// ǂݍݎۊ荞ݏ
void i2c_slave_read_handler(void)
{
	/* ~荞݋ */
	TWI0.SCTRLA |= TWI_PIEN_bm;

	/* ɏՕt */
	if(i2c_driver.bytes_received < I2C_RECEIVE_BUFFER_SIZE) {
		/* pM𒆎~ȂAPʏ */
		if(i2c_driver.abort) {
			i2c_slave_send_comptrans();
			i2c_slave_transaction_finished(I2C_RESULT_ABORTED);
			i2c_driver.abort = false;
		}

		/* ް擾AȌ͏ݎw */
		i2c_driver.received_data[i2c_driver.bytes_received] = i2c_slave_read();
		i2c_driver.bytes_received++;
	} else {
		/* ɏՕ */
		i2c_slave_send_nack();
		i2c_slave_transaction_finished(I2C_RESULT_BUFFER_OVERFLOW);
	}

}

// ݎۊ荞ݏ
void i2c_slave_write_handler(void)
{
	/* NACKMAݒPʏ */
	if((i2c_driver.bytes_sent > 0) && (TWI0.SSTATUS & TWI_RXACK_bm)) {
		i2c_slave_send_comptrans();
		i2c_slave_transaction_finished(I2C_RESULT_OK);
	} else {
		/* ACKMAް҂܂B */
		if(i2c_driver.bytes_sent < I2C_SEND_BUFFER_SIZE) {
			/* ްoAȌ͏ݎw */
			i2c_slave_write(i2c_driver.send_data[i2c_driver.bytes_sent]);
			i2c_driver.bytes_sent++;
		} else {
			/* ɏՕ */
			i2c_slave_send_comptrans();
			i2c_slave_transaction_finished(I2C_RESULT_BUFFER_OVERFLOW);
		}
	}
}

// ڽۊ荞ݏ
void i2c_slave_address_handler(void)
{
	/* pM𒆎~ȂAPʏ */
	if(i2c_driver.abort) {
		i2c_slave_send_comptrans();
		i2c_slave_transaction_finished(I2C_RESULT_ABORTED);
		i2c_driver.abort = false;
	} else {
		/* ~荞݂֎~ */
		TWI0.SCTRLA &= ~TWI_PIEN_bm;

		/* VMpϐؾ */
		i2c_driver.status = I2C_STATUS_BUSY;
		i2c_driver.result = I2C_RESULT_UNKNOWN;
		i2c_driver.bytes_received = 0;
		i2c_driver.bytes_sent = 0;

		/* ACK𑗏o */
		i2c_slave_send_ack();
	}
}

// ~ۊ荞ݏs
void i2c_slave_stop_handler(void)
{
	/* ~荞݂֎~ */
	TWI0.SCTRLA &= ~TWI_PIEN_bm;

	/* APIF */
	TWI0.SSTATUS = TWI_APIF_bm;

	/* VwߑoȂɏI */
	i2c_slave_transaction_finished(I2C_RESULT_OK);
}

// ޽Փˎۊ荞ݏ
void i2c_slave_collision_handler(void)
{
	i2c_driver.bytes_received = 0;
	i2c_driver.bytes_sent = 0;
	i2c_slave_transaction_finished(I2C_RESULT_TRANSMIT_COLLISION);
}

// ޽ُ펖ۊ荞ݏ
void i2c_slave_bus_error_handler(void)
{
	i2c_driver.bytes_received = 0;
	i2c_driver.bytes_sent = 0;
	i2c_slave_transaction_finished(I2C_RESULT_BUS_ERROR);
}

// PʏI
void i2c_slave_transaction_finished(i2c_status_t result)
{
	i2c_driver.result = result;
	i2c_driver.status = I2C_STATUS_READY;
}
