/**
 * \file
 *
 * \brief I2C]uײ
 * Atmel STARTI2C]uײނɊÂĊȌg
 * ȑfI2C]uײ
 *
 * \page 
 *
 * (c) 2018 Microchip Technology Inc.Ǝq
 *
 * ̏̏ƂāAMicrochipĳƉ̔hMicrochipi
 * ɌĎgp邱Ƃł܂BMicrochipĳ𔺂Ȃ(J 
 * ĳ܂)Oҿĳ̎gpɓKpO҂̋炷̂͂
 * ̐ӔCłB
 *
 * ̿ĳMicrochip"󂻂̂܂"ɂċ܂BNQAiA
 * ړIւ̓K̂ǂ̈Öق̕ۏ؂܂߁AIAÎI܂͖@߂ł낤
 * ̿ĳɂ͓Kp܂BႦMicrochip\iꂽAQ\
 * ƂĂA̔@Ɋւ炸A@ȂꍇłMicrochipͿĳɊ֘A
 * @Ȃނ̊ԐړIAʁAIAI܂͕KRIȑAQAp
 * ͎x̐ӔC𕉂܂B@ɂċő͈̔͂܂ŁA̿ĳ
 * Ɋ֘Aǂ̕@ł̑SɉĂAmicrochip̑ӔCźA΁A
 * Ȃ̿ĳɑ΂Microchip֒ڎxp̊z𒴂܂B
 */

#ifndef I2C_SLAVE_H
#define I2C_SLAVE_H

#include <stdbool.h>
#include <stdint.h>

#ifdef __cplusplus
extern "C" {
#endif

/*! \brief \ݒ\I2Cײޒ` */
#define I2C_SLAVE_ADDRESS               0x1
#define I2C_RECEIVE_BUFFER_SIZE         1
#define I2C_SEND_BUFFER_SIZE            1

/*! \brief Pʓ]Ԓ` */
typedef enum i2c_status_enum {
	I2C_STATUS_READY               = (0x00 << 0),
	I2C_STATUS_BUSY                = (0x01 << 0),
} i2c_status_t;

/*! \brief Pʓ]ʗ */
typedef enum i2c_result_enum {
	I2C_RESULT_UNKNOWN             = (0x00 << 0),
	I2C_RESULT_OK                  = (0x01 << 0),
	I2C_RESULT_BUFFER_OVERFLOW     = (0x02 << 0),
	I2C_RESULT_TRANSMIT_COLLISION  = (0x03 << 0),
	I2C_RESULT_BUS_ERROR           = (0x04 << 0),
	I2C_RESULT_FAIL                = (0x05 << 0),
	I2C_RESULT_ABORTED             = (0x06 << 0),
	I2C_RESULT_WAITING             = (0x07 << 0),
} i2c_result_t;

/*! \brief I2C]uײލ\
 *  I2C]u\́BI2Cްٰ݁AɏՕւ̈ʒuwqƕKvȕϐێ
 */
typedef struct twi_slave {
	uint8_t received_data[I2C_RECEIVE_BUFFER_SIZE]; /*!< ǂް */
	uint8_t send_data[I2C_SEND_BUFFER_SIZE];        /*!< ް */
	uint8_t bytes_received;                         /*!< M޲Đ */
	uint8_t bytes_sent;                             /*!< M޲Đ */
	i2c_status_t status;                            /*!< Pʓ]̏ */
	i2c_result_t result;                            /*!< Pʓ]̌ */
	bool abort;                                     /*!< ~ɑ΂۰ */
} i2c_slave_t;
extern i2c_slave_t i2c_driver;

/**
 * \brief I2C̪
 * Pʕ֎~Ԃɍ\ݒ肳ꍇAꂪ޲̸ۯ тŎĂ
 * ȂAI2Cւ̸ۯ͋֎~܂B
 *
 * \return Ȃ
 */
void i2c_slave_init(void);

/**
 * \brief ʐMpI2CJB֎~ȂΒPʕ
 *
 * \return Ȃ
 */
void i2c_slave_open(void);

/**
 * \brief ʐMpI2CBȂΒPʕ֎~
 * ڽF؂֎~
 *
 * \return Ȃ
 */
void i2c_slave_close(void);

/**
 * \brief I2C荞ݏɂČĂ΂֐
 * ߰ݸ ײނ߰ݸތJԂŌĂ΂꓾܂B
 *
 * \return Ȃ
 */
void i2c_slave_isr(void);

/**
 * \brief i2c_slaveް ڼ޽1޲ēǂݍ
 *
 * ֐͕ps\̏ꍇɑj~ꂸÂްp\̎ɂĂ΂
 * ׂłB
 *
 * \return i2c_slavePʕǂް
 */
uint8_t i2c_slave_read(void);

/**
 * \brief i2c_slaveް ڼ޽1޲ď
 *
 * ֐ްSɎ󂯓邱ƂłȂꍇɑj~ꂸÂɈSȎA
 * Aǂݍ݌Ăі߂łĂ΂ׂłB
 *
 * \param[in] data I2Cɏ镶
 *
 * \return Ȃ
 */
void i2c_slave_write(uint8_t data);

/**
 * \brief i2c_slaveűڽF؂
 * 1. ۯ тɂĎxꍇAPʕւ̸ۯ
 * 2. ʰ޳ڼ޽̋ޯĂݒ肷邱ƂɂI2C]u@\
 *
 * \return Ȃ
 */
void i2c_slave_enable(void);

/**
 * \brief Mڽ܂ްɑ΂ACK𑗏o
 * K؂ȎAAĂі߂łĂ΂ׂłB
 *
 * \return Ȃ
 */
void i2c_slave_send_ack(void);

/**
 * \brief Mڽ܂ްɑ΂NACK𑗏o
 * K؂ȎAAĂі߂łĂ΂ׂłB
 *
 * \return Ȃ
 */
void i2c_slave_send_nack(void);


/**
 * \brief Pʓ]̂߂COMPTRANSo
 * K؂ȎAAĂі߂łĂ΂ׂłB
 *
 * \return Ȃ
 */
void i2c_slave_send_comptrans(void);

/**
 * \brief ڽwԂ
 * ޽Ԃ̔FI2Cʰ޳ڽwԂؾĂ̂Ɏgp
 *
 * \return Ȃ
 */
void i2c_slave_goto_unaddressed(void);

#ifdef __cplusplus
}
#endif

#endif /* I2C_SLAVE_H */
